<?php
/**
 * @package genericviews
 * @author Ingo Schommer, SilverStripe Ltd. (<firstname>@silverstripe.com)
 * @author Sam Minnée, SilverStripe Ltd. (<firstname>@silverstripe.com)
 */
class CustomRecordController extends RecordController {

	/**
	 * Delete the current record
	 */
	public function doDelete($data, $form, $request) {
		if(!$this->currentRecord->canDelete(Member::currentUser())) {
			return $this->httpError(403);
		}
			
		$this->currentRecord->delete();
		$form->sessionMessage(
			_t('RecordController.DELETESUCCESS','Successfully deleted record'), 
			'good'
		);
		
		Director::redirect(Controller::join_links($this->parentController->Link()));;
		return parent::onBeforeDelete();

	}
	
}
?>